/*
WiMaster_test4
PIC to smart phone demo program.

target:PIC16F1936
environment:MPLAB v8.0
compiler:HI-TECH C

(c)T.Ishii

*/

#include<htc.h>
//#include <stdio.h>
//#include "usart.h"

//////////////////////////////////////
//		fuse						//
//////////////////////////////////////
__CONFIG(FOSC_INTOSC & WDTE_OFF & PWRTE_OFF & MCLRE_OFF 
& CP_OFF & CPD_OFF & BOREN_ON & CLKOUTEN_OFF & IESO_OFF& FCMEN_OFF);
__CONFIG(PLLEN_ON & LVP_OFF);

//////////////////////////////////////
//		define						//
//////////////////////////////////////
#define LED PORTBbits.RB7
#define ON 1
#define OFF 0

//////////////////////////////////////
//		initial setting				//
//////////////////////////////////////
void init_IO(){
	//clock
	OSCCON = 0b11110000;	//32MHz(4xPLL=enable FOSC=8MHz OSCSetting=CONFIGbit)
	//IO
	ANSELA = 0b00000000;	//1:Analog, 0:Digital
	ANSELB = 0b00100000;	//1:Analog, 0:Digital *RB5 is analog
	TRISB = 0b01111111;		//0:output 1:input    *TB7 is outout
	//UART
	SPBRG = 51;		//9600bps (FOSC=8MHz (without PLLx4))
	TXEN = 1;
	SYNC = 0;
	SPEN = 1;
	CREN=1;
	RCIE=1;			//RC intrrupt enable
	//ADC setting
	ADCON0 = 0b00110101;	//AN13 select, DONE=0, ADON=1
	ADCON1 = 0b00100000;	//Left, FOSC/2, VREF-=VSS, VREF+=AVDD
	//Intrrupt
	PEIE=1;
	GIE=1;
}	

//////////////////////////////////////
//		wait						//
//////////////////////////////////////
void wait_ms(int value){
	T2CON = 0b00000111;		//T2=ON Post1:1 Pre1:64 125KHz@1Sec(FOSC/4=8MHz)
	int i;
	for(i = 0; i < value; i++){
		TMR2 = 0;
		while(1){
			if(TMR2 > 124) break;	//actual TMR=125@1mS
		}
	}
	T2CON = 0b00111001;		//T2=OFF
}

//////////////////////////////////////
//		interrupt					//
//////////////////////////////////////
static void interrupt 
isr(void){
	//M荞
	if(RCIF == 1){
		unsigned char getData;
		RCIF = 0;
		getData = RCREG;
		//LED
		if(getData==0x01){
			LED=ON;
		}else if(getData==0x00){
			LED=OFF;
		}
	}
}

//////////////////////////////////////
//		ADC read					//
//////////////////////////////////////
//`lIOݒ莞AN13iRB5)ɐݒς
int readADC(void){
	GO_nDONE = 1;			//ADC start
	while(GO_nDONE);		//ADC done?
	return (int)ADRESH;
}

//////////////////////////////////////
//		main						//
//////////////////////////////////////
void main(){

	//ݒ
	init_IO();
	
	//300mSƂɃZT[f[^𑗂BM͊荞݂ŏB
	while(1){
		TXREG=readADC();
		wait_ms(100);			
	}
}

/*
2013.08.20	eXgvO쐬

*/
